LeetCode hot100-11

题目描述

题目链接:滑动窗口最大值

给你一个整数数组 nums,有一个大小为 k的滑动窗口从数组的最左侧移动到数组的最右侧。你只可以看到在滑动窗口内的 k 个数字。滑动窗口每次只向右移动一位。

返回 滑动窗口中的最大值。

示例 1:

**输入:**nums = 1,3,-1,-3,5,3,6,7, k = 3

输出:3,3,5,5,6,7

解释:

滑动窗口的位置 最大值


1 3 -1 -3 5 3 6 7 3

1 3 -1 -3 5 3 6 7 3

1 3 -1 -3 5 3 6 7 5

1 3 -1 -3 5 3 6 7 5

1 3 -1 -3 5 3 6 7 6

1 3 -1 -3 5 3 6 7 7

示例 2:

**输入:**nums = 1, k = 1

输出:1

提示:

  • 1 <= nums.length <= 105
  • -104 <= nums[i] <= 104
  • 1 <= k <= nums.length

思路解析

核心思想:维护一个双向队列,该队列队首元素为当前窗口最大值的下标。

遍历数组,将小于当前元素的队列末尾元素全部弹出,因为答案需要的是窗口中的最大元素,当窗口中有大的元素则较小的就不需要了,然后将当前元素下标放入队列中,并判断当前维护的最大值下标是否还在窗口中,如果不在需要弹出,最后将窗口中的最大值(队首元素)加入答案数组中。

注意:在循环弹出元素时需要先进行队列判空,防止查询空队列的尾元素;第一次将队列最大值加入数组应该是在遍历到第一个窗口的尾元素的位置(i==k-1),所以当i>=k-1才向答案数组添加答案。

代码实现

cpp 复制代码
class Solution {
public:
    vector<int> maxSlidingWindow(vector<int>& nums, int k) {
        vector<int> res;
        deque<int> dq;
        for(int i=0;i<nums.size();i++) {
            while(!dq.empty()&&nums[i]>=nums[dq.back()])//弹出队列中比当前元素小的元素
                dq.pop_back();
            dq.push_back(i);//放入当前元素
            if(dq.front()<i-k+1)//当队首元素超出窗口范围弹出
                dq.pop_front();
            if(i >= k - 1)//当遍历到第一个窗口尾元素向答案数组中加入当前最大值
                res.push_back(nums[dq.front()]);
        }
        return res;
    }
};
相关推荐
longlongzihan5 小时前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
封印师请假去地球钓鱼5 小时前
边解边变的问题:从“决策依赖“一词出发
人工智能·算法
今晚打老虎6 小时前
c++之提高A(前缀和)(第三课)
数据结构·c++·算法
不会就选b7 小时前
算法日常・每日刷题--<贪心>26
数据结构·算法
hetao17338378 小时前
2026-09-29 hetao1733837 的刷题记录
c++·算法
欣欣之王来了9 小时前
AI合规专项:AI算法透明度的合规要求
人工智能·算法
wzdark9 小时前
分块思想在算法优化中的实践与应用4
算法
Because_of_Her19 小时前
dfs-洪水填充技巧
笔记·算法·深度优先·洪水填充
小静AI工程实验室9 小时前
RSA 算法详解:从模幂原理到 OAEP 加密、PSS 签名与 Python 实验
python·算法
xzal1210 小时前
GESP Python笔记
笔记·python·算法